<!--
@license
Copyright (c) 2018 Pierre-Yves Gicquel. 
This code may only be used under the "Do whatever you want with code license"
-->
<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../paper-toggle-button/paper-toggle-button.html">
<link rel="import" href="../paper-radio-group/paper-radio-group.html">
<link rel="import" href="../thumbnail-view/thumbnail-view.html">
<link rel="import" href="../staticmedia-viewer/staticmedia-viewer.html">
<link rel="import" href="../common-styles/common-styles.html">
<link rel="import" href="../activity-feedback/activity-feedback.html">
<!--
`mcq-activity`
Une question à choix multiple
Il est possible d'associer un indice à la question sous forme d'un static-media
L'utilisateur est informé de son résultat via les paramètres correctMessage et wrongMessage
@demo demo/index.html
-->

<dom-module id="mcq-activity">
    <style include="common-styles">
        .question {
            padding: 10px;
            @apply(--paper-font-body2);

        }

        .validator {
            margin-top: 30px;
        }

        .correct {
            color: green;
        }

        .wrong {
            color: red;
        }
    </style>
    <template>
        <div id="mcqbody" class="resource">
            <div class="question" name="question">{{question}}</div>
            <div class="resourceBody">
                <iron-collapse opened=[[showClue]]>
                    <staticmedia-viewer resource-label="[[media.label]]" style="display:inline-flex;" mkdown="[[media.mkdown]]"></staticmedia-viewer>
                </iron-collapse>
                <template is="dom-if" if=[[!imageMode]] restamp>
                    <paper-radio-group selected={{textSelected}} id="textMcq" class="layout vertical wrap">
                        <paper-radio-button name="resp1">[[correctAnswer]]</paper-radio-button>
                        <template is="dom-repeat" items="[[distractorArray]]">
                            <paper-radio-button name="dist[[index]]">[[item.value]]</paper-radio-button>
                        </template>
                </template>
                <template is="dom-if" if=[[imageMode]] restamp>
                    <paper-radio-group selected={{imageSelected}} id="imageMcq" class="layout vertical wrap">
                        <paper-radio-button name="resp1">
                            <thumbnail-view thumbnail-path="/file/[[correctAnswer]]"></thumbnail-view>
                        </paper-radio-button>
                        <template is="dom-repeat" items="[[distractorArray]]">
                            <paper-radio-button name="dist[[index]]">
                                <thumbnail-view thumbnail-path="/file/[[item.value]]"></thumbnail-view>
                            </paper-radio-button>
                        </template>
                </template>
                <template is="dom-if" if="[[media]]" restamp=true>
                    <paper-toggle-button checked={{showClue}}>Indice</paper-toggle-button>
                </template>
                <paper-icon-button class="validator" src="check.png" on-click="validate"></paper-icon-button>

                <activity-feedback id="feedback" response-status=[[responseStatus]] correct-message=[[correctMessage]] wrong-message=[[wrongMessage]]></activity-feedback>
            </div>
        </div>
    </template>
    <script>
        (function () {
            'use strict';
            Polymer({
                is: 'mcq-activity',
                behaviors: [],

                ready: function () {
                },

                hideMessages:function(){
                    this.$.feedback.hideAll();
                }
                ,

                validate: function () {
                    if (this.textSelected && this.textSelected === 'resp1') {
                        this.responseStatus="correct";
                        return
                    }
                    if (this.imageSelected && this.imageSelected === 'resp1') {
                        this.responseStatus="correct";
                        return
                    }
                    this.responseStatus="wrong";
                },


                properties: {
                                        /*
                    * This property inform if the question has been answered (click on check)
                    * and if the response is "correct" or "wrong"
                    */
                    responseStatus:{
                        type: String,
                        notify : true,
                        value:'',
                        reflectToAttribute : true,
                    },

                    question: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',

                    },
                    correctMessage: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',

                    },
                    wrongMessage: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',

                    },
                    correctAnswer: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',
                    },
                    distractorArray: {
                        type: Array,
                        notify: true,
                        observer : '_resetQuestion',
                    },
                    imageMode: {
                        type: Boolean,
                        notify: true,
                        value: false,
                    },
                    media: {
                        type: Object,
                        notify: true,
                    },
                }
                ,
                _resetQuestion:function(){
                    this.responseStatus=''
                    this.textSelected=null
                    this.imageSelected=null
                },

            });
        })();
    </script>
</dom-module>